/***************************************************************************
                          main.c  -  description
                             -------------------
    begin                : Tue Jun 13 2000
    copyright            : (C) 2000 by Olivier ELEMENTO
    email                : olivier@ligm.igh.cnrs.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

//#include "pvm3.h"
#include <stdio.h>
#include <stdlib.h>
#include "tree.h"

//#include "memtrace.h"
#include "pvm3.h"

#define SLAVENAME "fastdupli_slave"
int main(int argc, char *argv[])
{
  //general
	FILE* fp;	
	int num, i, j, k;
	
	//pvm
	int mytid;
	int tids[32];
	int n, nproc, numt, who, msgtype, nhost, narch, bufid;
  float result[32];
  struct pvmhostinfo *hostp;

  char* rec_tree;
  //char* sent_data = strdup("ACTGTAGTGATTAGATT");
  int rec_parc, nb_trees, num_sets, data_share, data_rest;
	

  //loadData("iglcnogaps.phy");

  loadBootstrapData("iglcnogaps.bst", 100);
  /* enroll in pvm */
  mytid = pvm_mytid();
	/* Set number of slaves to start */
  pvm_config( &nhost, &narch, &hostp );

  nproc = nhost;
	printf("start up slave tasks\n");
  numt=pvm_spawn(SLAVENAME, (char**)0, 0, "", nproc, tids);
  if( numt < nproc ){
       printf("\n Trouble spawning slaves. Aborting. Error codes are:\n");
       for( i=numt ; i<nproc ; i++ ) {
          printf("TID %d %d\n",i,tids[i]);
       }
       for( i=0 ; i<numt ; i++ ){
          pvm_kill( tids[i] );
       }
       pvm_exit();
       exit(1);
  }
  printf("SUCCESSFUL\n");

  data_share = 100 / nproc;
  data_rest = 100 % nproc;

 	
	for (i=0; i<nproc; i++) {
		bufid = pvm_mkbuf(PvmDataDefault);
		pvm_setsbuf(bufid);
		pvm_pkint(&nb_species, 1, 1);
		pvm_pkint(&seq_length, 1, 1);
		num_sets = (i==nproc-1)?data_share+data_rest:data_share;
		pvm_pkint(&num_sets, 1, 1);
		//pvm_pkstr(sent_data);
		for (k=i*data_share; k<i*data_share+num_sets; k++) {
			data = bst_data[k];
			for (j=0; j<nb_species; j++) {
				printf("sending %s to task %d\n", data[j], tids[i]);
				pvm_pkstr(data[j]);
			}
		}
		//printf("sending %s to task %d\n", data[0], tids[i]);
		pvm_send(tids[i], 0);
		pvm_freebuf(bufid);
	}	
	
	printf("Start receiving data\n");
	for (i=0; i<100; i++) {
		pvm_recv(-1, 5);
		//printf("received!");
		pvm_upkint(&rec_parc, 1, 1);
		pvm_upkint(&nb_trees, 1, 1);
		for (j=0; j<nb_trees; j++) {
			rec_tree = (char*)calloc(100, sizeof(char));
			pvm_upkstr(rec_tree);
			printf("tree = %s, parci=%d\n", rec_tree, rec_parc);
		}
		
	}
	
	/* Program Finished exit PVM before stopping */
  pvm_exit();
	

  return EXIT_SUCCESS;
}
